<template>
  <div
    class="icon"
    :class="{
      [`icon--size-${size}`]: !!size,
    }"
  >
    <component
      :is="component"
      class="icon__icon"
    />
  </div>
</template>

<script>
export default {
  name: 'Icon',
  props: {
    type: {
      type: String,
      required: true,
    },
    size: {
      type: String,
      default: 'sm',
    },
  },
  computed: {
    component() {
      return require(`./icons/${this.type}.svg`).default;
    },
  },
};
</script>

<style lang="scss">
  .icon {
    @each $key, $size in (
        (xxs, 8px),
        (xs, 12px),
        (sm, 14px),
        (md, 16px),
        (lg, 20px),
        (xl, 24px),
        (xlg, 48px),
    )   {
      &--size-#{$key} {
        height: $size;
        width: $size;
      }
    }

    &__icon {
      display: block;
      height: 100%;
      width: 100%;
      pointer-events: none;
      fill: currentColor;

      transition: .15s fill;
    }
  }
</style>
